include wildcard.e
include machine.e
include get.e
include x-os.e
 with trace
 trace(1)
-- without type_check
-- without warning
-- with profile

object temp, Get_Data, Inp_Data, GetV_Data, From_XPR
atom i, F_Loc, Sdebug
atom DbgMode, PutNum, XPRNum, CFR_Pointer, CFR_Origin, CFR_IF
sequence Comp_XPR, Var, VarData, PutPlace, PutLen, M_Var, WatchForVar, WatchForVarState
Comp_XPR = {22}
Var = {}
DbgMode = 0
PutNum = 0
PutPlace = {}
PutLen = {}
M_Var = {}
CFR_Pointer = -5
CFR_Origin = -5
CFR_IF = 0

constant Name = 1
constant Alloc = 2
constant Length = 3

temp = command_line()

procedure CFR_Tag(atom Point, atom Orig)
  CFR_Pointer = Point
  CFR_Origin = Orig
end procedure

procedure CFR_IF_Tag(atom Point, atom Orig, sequence WFV, sequence WFVS)
  CFR_Pointer = Point
  CFR_Origin = Orig
  WatchForVar = WFV
  WatchForVarState = WFVS
end procedure






function Ifc(sequence ReadIn)
  if compare(upper(Comp_XPR[i]), ReadIn) = 0 then
    return 0
  else
    return -1
  end if
end function

procedure FlowControl(integer CommLen)
    i = i + CommLen
end procedure

function Check_I()
  if i > length(Comp_XPR) then
    return 1
  else
    return -1
  end if
end function

  

procedure PutLenModify(sequence args)
  if compare(args, "Free_PutModule") = 0 then  
    free(PutPlace[PutNum])
    PutLen = PutLen[1..PutNum-1]
    PutPlace = PutPlace[1..PutNum-1]
    PutNum = PutNum - 1
  else
  PutLen = PutLen & length(args)
  PutNum = PutNum + 1
  end if
end procedure

procedure VarModify(atom args, object args2)
  if args = 1 then
    Var = append(Var, args2)
  elsif args = 2 then
    Var = Var & args2
  elsif args = 3 then
    Var = Var & length(args2)
  else
  printf(1, "\nStrange VarModify(%d)\n", args)
  end if
end procedure

function Malloc_seq(sequence args)
  return allocate(length(args))
end function

function Var_Locate(sequence args)
  return find(args, Var)
end function

procedure CFR_IF_ChVar()
   
    F_Loc = Var_Locate(WatchForVar)

    if F_Loc = 0 then
      printf(Sdebug, "(B%d/CFR_IF-NOTE)Var %s not init, dying\n", {i-2, WatchForVar})
      abort(1)
    end if

    if DbgMode = 1 then
      printf(Sdebug, "(B%d/CFR_IF)VarLoc = %d, VarLen = %d\n", {i-2,Var[F_Loc+1], Var[F_Loc+2]})
    end if

    VarData = peek({Var[F_Loc+1], Var[F_Loc+2]})

    if compare(VarData, WatchForVarState) = 0 then
      i = CFR_Origin
    end if

    Var = Var[1..length(Var)-3]

end procedure


procedure CFR_Handler()
  if i = CFR_Pointer and CFR_IF = 0 then
        i = CFR_Origin -- + 2
      elsif i = CFR_Pointer and CFR_IF = 1 then
      CFR_IF_ChVar()
   end if
end procedure

procedure CFR_Finder()

for k = 2 to (length(Comp_XPR)-1) do

  if compare(upper(Comp_XPR[k]), "CFR") = 0 then
    printf(1, "---CFR found at bloc %d. Pointer -> %d\n\n", {k-1, Comp_XPR[k+1]})
    CFR_IF = 0
    CFR_Tag(Comp_XPR[k+1]+2, k)

  else
  end if
end for
end procedure

procedure CFR_IF_Finder()

for k = 2 to (length(Comp_XPR)-1) do

  if compare(upper(Comp_XPR[k]), "CFR_IF") = 0 then
    printf(1, "---CFR_IF found at bloc %d. Pointer -> %d\n\n", {k-1, Comp_XPR[k+3]})
    CFR_IF = 1
    CFR_IF_Tag(Comp_XPR[k+3]+2, k, Comp_XPR[k+1], Comp_XPR[k+2])

  else
  end if
end for
end procedure




if length(temp) < 3 then
  puts(1, "No XPRogram filename specified\n")
  abort(666)
end if

if length(temp) > 3 then
  if compare(temp[4], "-debug") = 0 then
    DbgMode = 1
    Sdebug = 1
    puts(1, "Debug mode ON\n")
  elsif compare(temp[4], "-sdebug") = 0 then
    DbgMode = 1
    Sdebug = open("s_out.dat", "w")
    puts(1, "Silent debug ON -- Filename s_out.dat\n")

    else

   end if
end if
XPRNum = open(temp[3], "r")

if XPRNum = -1 then
  puts(1, "File doesn't exist!")
  abort(444)
end if

printf(1, "XPRNum  %d\n", XPRNum)

  From_XPR = get(XPRNum)  

  if compare(From_XPR[1], GET_FAIL) = 0 then
    puts(1, "GET_FAIL! Syntax error in skeleton\n")
    abort(666)
  elsif compare(From_XPR[1], GET_SUCCESS) = 0 then
    puts(1, "GET_SUCCESS, XPR OK!\n")
    Comp_XPR = Comp_XPR & From_XPR[2]
  end if



printf(1, "XProL Thingamajig v%d \"Shent\"\n", Comp_XPR[1])
printf(1, "Loaded total %d blocs\n", length(Comp_XPR) - 1)

  if DbgMode = 1 then
  printf(Sdebug, "(INIT)Total %d blocs, v%d\n", {length(Comp_XPR)-1, Comp_XPR[1]})
  end if

puts(1, "The XPR has been loaded, press a key...\n\n")
temp = wait_key()

i = 2

puts(1, "---Checking for a CFR...\n")
CFR_Finder()
CFR_IF_Finder()

if CFR_Pointer = -5 then puts(1, "---No CFR\n\n")
end if


while 1 do

if CFR_Pointer != -5 then CFR_Handler()
end if


if Check_I() = 1 then
  abort(1)
else

  if Ifc("PR:") = 0 then

    puts(1, Comp_XPR[i+1])

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/PR:)\n", {i-2})
    end if


      FlowControl(1)

  elsif Ifc("VER") = 0 then
    printf(1, "v%d", Comp_XPR[1])
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/VER)\n", {i-2})
    end if

  elsif Ifc("NOP") = 0 then
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/NOP)\n", {i-2})
    end if


  elsif Ifc("PUT") = 0 then



     PutLenModify(Comp_XPR[i+1])


    PutPlace = PutPlace & allocate(length(Comp_XPR[i+1]))

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/PUT)MALLOC %d bytes, PutNum %d\n", {i-2,length(Comp_XPR[i+1]), PutNum})
    end if





    if DbgMode = 1 then
    printf(Sdebug, "(B%d/PUT)PutLen %d\n", {i-2,length(Comp_XPR[i+1])})
    end if


    poke(PutPlace[PutNum], Comp_XPR[i+1])

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/PUT)POKE '%s', %d\n", {i-2,Comp_XPR[i+1], PutPlace[PutNum]})
    end if

     
      

 FlowControl(1) 



  elsif Ifc("GET") = 0 then

    if PutNum = 0 then
      puts(1, "No stack!")
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/GET-ERR!)NoStack\n", {i-2})
    end if

      abort(1)
    end if


    Get_Data = peek({PutPlace[PutNum], PutLen[PutNum]})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/GET)GET %d bytes, from %d, PutNum %d\n", {i-2,PutLen[PutNum], PutPlace[PutNum], PutNum})
    end if

    puts(1, Get_Data)

--    free(PutPlace[PutNum])
      PutLenModify("Free_PutModule")
--    PutNum = PutNum - 1



  elsif Ifc("NLIN") = 0 then

    newline()
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/NLIN)\n", {i-2})
    end if


  elsif Ifc("PVAR") = 0 then

     VarModify(Name, Comp_XPR[i+1])

    temp = Malloc_seq(Comp_XPR[i+2])

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/PVAR)MALLOC %d bytes, at %d\n",{i-2,length(Comp_XPR[i+2]), temp})
    end if

    VarModify(Alloc, temp)

    VarModify(Length, Comp_XPR[i+2])

    poke(temp, Comp_XPR[i+2])

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/PVAR)Var: %s, Data: %s\n", {i-2,Comp_XPR[i+1], Comp_XPR[i+2]})
    end if

   

     FlowControl(2) 



  elsif Ifc("GVAR") = 0 then

      F_Loc = Var_Locate(Comp_XPR[i+1])

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/GVAR)Var: %s\n", {i-2,Comp_XPR[i+1]})
    end if


    if F_Loc = 0 then
      printf(1, "\nUnknown Var name %s!!\n", {Comp_XPR[i+1]})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/GVAR-ERR!)Var =? %s\n", {i-2, Comp_XPR[i+1]})
    end if

      abort(1)
    else
    end if

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/GVAR)VarLoc = %d, VarLen = %d\n", {i-2,Var[F_Loc+1], Var[F_Loc+2]})
    end if

    VarData = peek({Var[F_Loc+1], Var[F_Loc+2]})
    puts(1, VarData)

     FlowControl(1) 


  elsif Ifc("INP") = 0 then
   
    temp = gets(0)
    Inp_Data = temp[1..length(temp)-1]
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/INP)Var: %s, Data: %s\n", {i-2,Comp_XPR[i+1], temp})
    end if

--    Var = append(Var,Comp_XPR[i+1])
     VarModify(Name, Comp_XPR[i+1])
    temp = Malloc_seq(Inp_Data)

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/INP)MALLOC %d bytes, at %d\n",{i-2,length(Inp_Data), temp})
    end if

--    Var = Var & temp
      VarModify(Alloc, temp)
--    Var = Var & length(Inp_Data)
      VarModify(Length, Inp_Data)
    poke(temp, Inp_Data)


 FlowControl(1) 



  elsif Ifc("GET_V") = 0 then

    if PutNum = 0 then
      puts(1, "No stack!")
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/GET_V-ERR!)NoStack\n", {i-2})
    end if

      abort(1)
    end if


    GetV_Data = peek({PutPlace[PutNum], PutLen[PutNum]})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/GET_V)GET %d bytes, from %d, PutNum %d\n", {i-2,PutLen[PutNum], PutPlace[PutNum], PutNum})
    end if


 --   Var = append(Var,Comp_XPR[i+1])
    VarModify(Name, Comp_XPR[i+1])
--    temp = allocate(length(GetV_Data))
      temp = Malloc_seq(GetV_Data)
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/GET_V)MALLOC %d bytes, at %d\n",{i-2,length(GetV_Data), temp})
    end if

--    Var = Var & temp
    VarModify(Alloc, temp)
--    Var = Var & length(GetV_Data)
    VarModify(Length, GetV_Data)
    poke(temp, GetV_Data)

--    free(PutPlace[PutNum])
--    PutNum = PutNum - 1
    PutLenModify("Free_PutModule")

 FlowControl(1) 


  elsif Ifc("MALLOC") = 0 then

    temp = allocate(Comp_XPR[i+1])

    M_Var = append(M_Var, temp)
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/MALLOC)MALLOC %d bytes, at %d -- M_Var %d\n",{i-2,Comp_XPR[i+1], temp, length(M_Var)})
    end if


 FlowControl(1) 


  elsif Ifc("MGET") = 0 then
    if length(M_Var) < Comp_XPR[i+1] then
      printf(1, "M_Var < %d(%d)\n", {Comp_XPR[i+1], length(M_Var)})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/MGET-ERR!)M_Var<%d(%d)\n", {i-2, Comp_XPR[i+1], length(M_Var)})
    end if

      abort(1)
    end if

    
    Get_Data = peek({M_Var[Comp_XPR[i+1]], Comp_XPR[i+2]})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/MGET)MGET from M_Var %d (%d) %d bytes\n",{i-2,Comp_XPR[i+1], M_Var[Comp_XPR[i+1]], Comp_XPR[i+2]})
    end if

    puts(1, Get_Data)



 FlowControl(2) 


  elsif Ifc("MPUT") = 0 then

    if length(M_Var) < Comp_XPR[i+1] then
      printf(1, "M_Var < %d(%d)\n", {Comp_XPR[i+1], length(M_Var)})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/MPUT-ERR!)M_Var<%d(%d)\n", {i-2, Comp_XPR[i+1], length(M_Var)})
    end if

      abort(1)
    end if

    temp = Comp_XPR[i+2]
    poke(M_Var[Comp_XPR[i+1]], temp)
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/MPUT)MPUT to M_Var %d (%d) %d bytes\n",{i-2,Comp_XPR[i+1], M_Var[Comp_XPR[i+1]], length(Comp_XPR[i+2])})
    end if
    



 FlowControl(2) 

  elsif Ifc("D-MPUT") = 0 then

    puts(1, "The D-MPUT command is EXTREMELY bad for your health. Why? Because it means Direct Memory outPut!\n")
    puts(1, "And THAT means, that you can screw up your computer pretty badly IF you don't know what you're doing!\n")
    puts(1, "Sooo, if you REALLY know what you're doing, press ENTER now, otherwise press Ctrl-BREAK!\n")
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/D-MPUT(WARN))\n", {i-2})
    end if

    temp = wait_key()

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/D-MPUT)Yowzie! Lunatic using D-MPUT to address %d, %d bytes, data %s", {i-2,Comp_XPR[i+1], length(Comp_XPR[i+2]), Comp_XPR[i+2]})
    end if
    temp = Comp_XPR[i+2]
    poke(Comp_XPR[i+1], temp)

 FlowControl(2) 



  elsif Ifc("D-MGET") = 0 then


    if compare(upper(Comp_XPR[i+3]), "HEX") = 0 then


      temp =  peek({Comp_XPR[i+1], Comp_XPR[i+2]})

      for j = 1 to length(temp) do
        printf(1, "%x ", temp[j])
      end for
      newline()

    elsif compare(upper(Comp_XPR[i+3]), "DEC") = 0 then


      temp =  peek({Comp_XPR[i+1], Comp_XPR[i+2]})

      for j = 1 to length(temp) do
        printf(1, "%d ", temp[j])
      end for
      newline()

    elsif compare(upper(Comp_XPR[i+3]), "CHR") = 0 then


      temp =  peek({Comp_XPR[i+1], Comp_XPR[i+2]})

      for j = 1 to length(temp) do
        printf(1, "%s", temp[j])
      end for
      newline()



    else
      printf(1, "Unknown type modifier %s", {Comp_XPR[i+2]})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/D-MGET-ERR!)T-Mod =? %s\n", {i-2, Comp_XPR[i+2]})
    end if

      abort(666)
    end if

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/D-MGET) Address %d, %d bytes at %s mode\n", {i-2,Comp_XPR[i+1], Comp_XPR[i+2], Comp_XPR[i+3]})
    end if





 FlowControl(3) 


  elsif Ifc("WFK") = 0 then
  temp = wait_key()
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/WFK)\n", {i-2})
    end if


  elsif Ifc("END") = 0 then
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/END)\n", {i-2})
    end if
    abort(1)

  elsif Ifc("JE") = 0 then

    if DbgMode = 1 then
      printf(Sdebug, "(B%d/JE)IF_%s_CONTENT == %s   JMP %d\n", {i-2, Comp_XPR[i+1], Comp_XPR[i+2], Comp_XPR[i+3]})
    end if
     
--    F_Loc = find(Comp_XPR[i+1], Var)
      F_Loc = Var_Locate(Comp_XPR[i+1])
    if F_Loc = 0 then
      printf(1, "\nUnknown Var name %s!!\n", {Comp_XPR[i+1]})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/JE-ERR!)Var =? %s\n", {i-2, Comp_XPR[i+1]})
    end if

      abort(1)
    else
    end if

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/JE)VarLoc = %d, VarLen = %d\n", {i-2,Var[F_Loc+1], Var[F_Loc+2]})
    end if

    VarData = peek({Var[F_Loc+1], Var[F_Loc+2]})

    if compare(VarData, Comp_XPR[i+2]) = 0 then
      if length(Comp_XPR)-1 < Comp_XPR[i+3]+1 then
        printf(1, "Invalid JMP attempt! Comp_XPR < %d (%d)\n", {i-2,Comp_XPR[i+3]+1, length(Comp_XPR)})
        if DbgMode = 1 then
        printf(Sdebug, "(B%d/JE-ERR!)Inv. JMP C_X<%d(%d)\n", {i-2,Comp_XPR[i+3]+1, length(Comp_XPR)})
        end if

        abort(666)
      else
        i = Comp_XPR[i+3] + 1
      end if
    else

 FlowControl(3) 

    end if
    
    Var = Var[1..length(Var)-3]



  elsif Ifc("JMP") = 0 then

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/JMP) JMP %d\n", {i-2,Comp_XPR[i+1]+1})
    end if

      if length(Comp_XPR)-1 < Comp_XPR[i+1] +1 then
        printf(1, "Invalid JMP attempt! Comp_XPR < %d (%d)\n", {i-2,Comp_XPR[i+1]+1, length(Comp_XPR) })
        if DbgMode = 1 then
        printf(Sdebug, "(B%d/JMP-ERR!)Inv. JMP C_X<%d(%d)\n", {i-2,Comp_XPR[i+1]+1, length(Comp_XPR)})
        end if
      else
        i = Comp_XPR[i+1]+1
      end if


  elsif Ifc("INCR") = 0 then

--    F_Loc = find(Comp_XPR[i+1], Var)
      F_Loc = Var_Locate(Comp_XPR[i+1])
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/INCR)Var: %s\n", {i-2,Comp_XPR[i+1]})
    end if


    if F_Loc = 0 then
      printf(1, "\nUnknown Var name %s!!\n", {Comp_XPR[i+1]})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/INCR-ERR!)Var =? %s\n", {i-2, Comp_XPR[i+1]})
    end if

      abort(1)
    else
    end if

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/INCR)VarLoc = %d, VarLen = %d\n", {i-2,Var[F_Loc+1], Var[F_Loc+2]})
    end if

    VarData = peek({Var[F_Loc+1], Var[F_Loc+2]})
    VarData = VarData + Comp_XPR[i+2]
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/INCR)%s =+ %d\n", {i-2,Comp_XPR[i+1],Comp_XPR[i+2]})
    end if

    poke(Var[F_Loc+1], VarData)

    
 FlowControl(2) 


  elsif Ifc("CHVAR") = 0 then


--    F_Loc = find(Comp_XPR[i+1], Var)
      F_Loc = Var_Locate(Comp_XPR[i+1])
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/CHVAR)Var: %s\n", {i-2,Comp_XPR[i+1]})
    end if


    if F_Loc = 0 then
      printf(1, "\nUnknown Var name %s!!\n", {Comp_XPR[i+1]})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/CHVAR-ERR!)Var =? %s\n", {i-2, Comp_XPR[i+1]})
    end if

      abort(1)
    else
    end if

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/CHVAR)VarLoc = %d, VarLen = %d\n", {i-2,Var[F_Loc+1], Var[F_Loc+2]})
    end if

    VarData = peek({Var[F_Loc+1], Var[F_Loc+2]})
    VarData = Comp_XPR[i+2]
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/CHVAR)%s = %s\n", {i-2,Comp_XPR[i+1],Comp_XPR[i+2]})
    end if

    poke(Var[F_Loc+1], VarData)
    

    
 FlowControl(2) 





  elsif Ifc("ALT_JE") = 0 then

    if DbgMode = 1 then
      printf(Sdebug, "(B%d/ALT_JE)IF_%s_CONTENT == %s   JMP %d\n", {i-2, Comp_XPR[i+1], Comp_XPR[i+2], Comp_XPR[i+3]})
    end if

    --F_Loc = find(Comp_XPR[i+1], Var)
    F_Loc = Var_Locate(Comp_XPR[i+1])
    if F_Loc = 0 then
      printf(1, "\nUnknown Var name %s!!\n", {Comp_XPR[i+1]})
    if DbgMode = 1 then
    printf(Sdebug, "(B%d/ALT_JE-ERR!)Var =? %s\n", {i-2, Comp_XPR[i+1]})
    end if

      abort(1)
    else
    end if

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/ALT_JE)VarLoc = %d, VarLen = %d\n", {i-2,Var[F_Loc+1], Var[F_Loc+2]})
    end if

    VarData = peek({Var[F_Loc+1], Var[F_Loc+2]})

    if compare(VarData, Comp_XPR[i+2]) = 0 then
      if length(Comp_XPR)-1 < Comp_XPR[i+3] +1 then
        printf(1, "Invalid JMP attempt! Comp_XPR < %d (%d)\n", {i-2,Comp_XPR[i+3]+1, length(Comp_XPR) })
        if DbgMode = 1 then
        printf(Sdebug, "(B%d/ALT_JE-ERR!)Inv. JMP C_X<%d(%d)\n", {i-2,Comp_XPR[i+3]+1, length(Comp_XPR)})
        end if

        abort(666)
      else
        i = Comp_XPR[i+3] + 1
      end if
    else
 FlowControl(3) 
   end if
    
elsif Ifc("CFR") = 0 then

 FlowControl(1) 

elsif Ifc("CFR_IF") = 0 then

 FlowControl(3) 




  else
    printf(1, "Unknown command %s at bloc %d\n", {Comp_XPR[i], i-2})

    if DbgMode = 1 then
    printf(Sdebug, "(B%d/XPROL-ERR!)Comm =? %s\n", {i-2,Comp_XPR[i]})
    end if

    exit
  end if
    i = i + 1
    
end if


end while


